;Form (Dialog) Functions

;Written by Thomas A. Stevenson (wargamer)

;   thomas99@phenixcable.net

;3/20/01

;Blitzbasic 1.43



;I needed a properties type dialog form for a Map drawing program

;I am creating so I wrote this.



;This is not GUI, It creates a form, and controls it.



;There are still improvements to be made but I quite happy

;with the basic approach



;I tried to comment the code sufficiently to ensure others

;will be able to adapt it without problems, but feel free to

;write me if needed.



;Please share any new objects 





Function Obj_assign(d,typ,x,y,w,h,bord,insd,fnt,thck,txt$,ret$)



	If Form(D,0)=MaxDialogItems Then Return



  ;increament number of objects in obj()

	Tot_obj=Tot_obj+1

	;increament number of objects for Form(d,)

	Form(D,0)=Form(D,0)+1

	;store object index in Form(d,) 

	Form(d,Form(D,0))=Tot_obj

	

	obj(Tot_obj,0)=typ

	obj(Tot_obj,1)=x

	obj(Tot_obj,2)=y

	obj(Tot_obj,3)=w

	obj(Tot_obj,4)=h

	obj(Tot_obj,5)=bord

	obj(Tot_obj,6)=insd

	obj(Tot_obj,7)=fnt

	obj(Tot_obj,8)=thck

	objText$(Tot_obj)=txt$

	ReturnText$(Tot_obj)=ret$

	

	Return Tot_obj

	

End Function





Function Form_Object(ret$,fld,value)

	For i=1 To Tot_obj

		If ret$=ReturnText$(i)

			If fld>-1 Then obj(i,fld)=value

			Return i

		EndIf

	Next

	Stop

End Function



;*************************************************************************



Function Form_Image(D)

	;calling routine must redraw backbuffer()

	;first object is the container for the rest



	mObj=Form(D,1)

	;draw box in border color first

	colorset(obj(mObj,5))

	Rect 0,0,obj(mObj,3),obj(mObj,4)

	colorset(obj(mObj,6))

	xy=obj(mObj,8) 

	If xy=-1

		x=0: y=0

		w=obj(mObj,3): h=obj(mObj,4)

	 	ColorSet(White)

	 	Rect x,y,w,h,0

		ColorSet(Black)

		;Line x,y,x+w,y: Line x,y,x,y+h

	  Line x+1,y+h-1,x+w,y+h-1: Line x+w-1,y+1,x+w-1,y+h

	Else

		Rect xy,xy,obj(mObj,3)-2*xy,obj(mObj,4)-2*xy

	EndIf



	;now draw remaining objects on form relative to container origin

	For n=1 To Form(D,0)

		i=Form(D,n)

		Select 	obj(i,0)

		Case 0	;Master container, already drawn

		Case 1 	;text (no background)

			If obj(i,7)>0 Then SetFont(obj(i,7))

			colorset(obj(i,5))

			Text obj(i,1),obj(i,2),objText$(i),obj(i,6)

		Case 2 ;label

			x=obj(i,1)

			If obj(i,8) Then x=x-obj(i,3)/2  ;center label on x

			If obj(i,7)>0 Then SetFont(obj(i,7))

			colorset(obj(i,6))

			Rect x,obj(i,2),obj(i,3),obj(i,4)

			colorset(obj(i,5))

			Rect x,obj(i,2),obj(i,3),obj(i,4),0

			Text x+obj(i,3)/2,obj(i,2),objText$(i),1

		Case 3 ;button

			FC=obj(i,5) 

			BC=obj(i,6) 

			ButtonBox(obj(i,1),obj(i,2),obj(i,3),obj(i,4),objText$(i),obj(i,7),FC,BC,False)

		Case 4 	;Ckbox

			Colorset(white)

			w=obj(i,3) + 1 -obj(i,3) Mod 2	; increse w by 1 if even

			h=w-1

			Rect obj(i,1),obj(i,2),w,h

			Colorset(black)

			Rect obj(i,1),obj(i,2),w,h,0

			If obj(i,7)>0 Then SetFont(obj(i,7))

			Text obj(i,1)+w+4,obj(i,2),objText$(i)

		Case 5	;radio

			Colorset(white)

			Oval obj(i,1),obj(i,2),obj(i,3),obj(i,3)

			Colorset(black)

			Oval obj(i,1),obj(i,2),obj(i,3),obj(i,3),0

			If obj(i,7)>0 Then SetFont(obj(i,7))

			Text obj(i,1)+obj(i,3)+4,obj(i,2),objText$(i)

		Case 6	;Button

			If obj(i,7)>0 Then SetFont(obj(i,7))

			colorset(obj(i,6))

			Rect obj(i,1),obj(i,2),obj(i,3),obj(i,4)

			colorset(obj(i,5))

			Rect obj(i,1),obj(i,2),obj(i,3),obj(i,4),0

			Text obj(i,1)+obj(i,3)/2,obj(i,2),objText$(i),1

		Case 7	;Hslider

			w=obj(i,3):h=obj(i,4)

			colorset(white)

  		Rect obj(i,1),obj(i,2),w,h

		  colorset(LtGray)

		  For y=0 To h

				x0= y Mod 2

		  	For x=x0 To w Step 2

			  	Plot obj(i,1)+x,obj(i,2)+y

				Next

		  Next

		Case 8	;Vslider

			w= obj(i,3):h=obj(i,4)

			colorset(white)

  		Rect obj(i,1),obj(i,2),w,h

		  colorset(LtGray)

		  For y=0 To h

				x0= y Mod 2

		  	For x=x0 To w Step 2

			  	Plot obj(i,1)+x,obj(i,2)+y

				Next

		  Next

		Case 9	;Title bar

			If obj(i,7)>0 Then SetFont(obj(i,7))

			Select obj(i,8)

			Case 1

				tw=(obj(i,3)-StringWidth(objText$(i)))/2

				colorset(obj(i,6))

				For y=3 To obj(i,4) Step 2

					Line 2,y,tw,y

					Line obj(i,3)+2-tw,y,obj(i,3)-2,y

				Next

				Line 2,y,obj(mObj,3)-2,y

				colorset(obj(i,5))

				Text obj(i,3)/2,2,objText$(i),1

			Default

				For x=2 To obj(i,3)-2

					b=55+x*200/obj(i,3)

					rg=x*100/obj(i,3)

					Color rg,rg,b

					Line obj(i,1)+x,obj(i,2)+1,obj(i,1)+x,obj(i,2)+obj(i,4)-1

				Next

				Color 255,255,255

				Text obj(i,1)+2,obj(i,2)+2,objText$(i)

			End Select

		Case 10 ;list

			colorset(White)

			Rect obj(i,1),obj(i,2),obj(i,3),obj(i,4)		;fill

			colorset(black)

			Rect obj(i,1),obj(i,2),obj(i,3),obj(i,4),0  ;border

		Case 11	;slider for list box

			Origin obj(i,1),obj(i,2)

			SliderBackground(obj(i,3),obj(i,4))

			Origin 0,0

			;Only vertical slider allowed

			If obj(obj(i,6),7)>0 Then SetFont(obj(obj(i,6),7))

			fh=FontHeight()

			;number of pixels per Item in list

			obj(i,8)=fh	

			;initial slider position

			obj(i,5)=obj(i,2)

			;total list size in terms of pixels

			Tpixs=fh*(obj(obj(i,6),8))

			;slider size =slider area * WinH/Total Window height

			VR=Int(obj(obj(i,6),4)/fh)*fh

			obj(i,7)=obj(i,4)*VR/Tpixs

		Case 12	;drop down selector

			If obj(i,7)>0 Then SetFont(obj(i,7))

			fh=FontHeight()

			colorset(white)

			Rect obj(i,1),obj(i,2),obj(i,3),obj(i,4)

			colorset(black)

			Rect obj(i,1),obj(i,2),obj(i,3),obj(i,4),0

			Rect obj(i,1)+obj(i,3)-obj(i,4),obj(i,2),obj(i,4),obj(i,4),0

			For k=0 To obj(i,4)/3

				y=obj(i,2)+obj(i,4)-obj(i,4)/3-k

				x=obj(i,1)+obj(i,3)-obj(i,4)/2

				Plot x,y

				For j=0 To w2

					Plot x+j,y

					Plot x-j,y

				Next

				w2=w2+1

			Next

		Case 13	;image

			If obj(i,8)=0 Then DrawImage obj(i,5),obj(i,1),obj(i,2)

		Default

		End Select

  Next

	dHand=CreateImage(obj(mObj,3),obj(mObj,4))

	GrabImage dHand,0,0

	

	Return dHand



End Function



;*************************************************************************



Function Form_Update(D)

	

	mObj=Form(D,1)

	Origin obj(mObj,1),obj(mObj,2)

	

	For n=1 To Form(D,0)

		i=Form(D,n)

		Select 	obj(i,0)

		Case -1 ;Updatable text (no background)

			If obj(i,7)>0 Then SetFont(obj(i,7))

			colorset(obj(i,5))

			Text obj(i,1),obj(i,2),objText$(i),obj(i,6)

		Case 1 	;text (no background)

		Case 2 	;label

		Case 3 	;button

			If obj(i,8)=True Then

				FC=obj(i,5) 

				BC=obj(i,6) 

				ButtonBox(obj(i,1),obj(i,2),obj(i,3),obj(i,4),objText$(i),obj(i,7),FC,BC,True)

			EndIf

		Case 4 	;Ckbox

			If obj(i,8) Then

				w=obj(i,3) + 1 -obj(i,3) Mod 2	; increse w by 1 if even

				h=w-1

 				x0=obj(i,1)+2:	x2=obj(i,1)+w-4

				y0=obj(i,2)+2:	y2=obj(i,2)+h-3

				Colorset(black)

				Line x0  ,y0,  x2+1,y2+1

				Line x0+1,y0,x2+1+1,y2+1

				Line x0  ,y2,x2  ,y0

				Line x0+1,y2,x2+1,y0

			EndIf

		Case 5	;radio

			Colorset(black)

			If obj(i,5) Then Oval obj(i,1)+2,obj(i,2)+2,obj(i,3)-4,obj(i,3)-4

		Case 6	;Edit text box

			If obj(i,7)>0 Then SetFont(obj(i,7))

			colorset(obj(i,6))

			Rect obj(i,1)+1,obj(i,2)+1,obj(i,3)-2,obj(i,4)-2

			colorset(obj(i,5))

			Viewport obj(mObj,1)+obj(i,1)+1,	obj(mObj,2)+obj(i,2)+1,	obj(i,3)-2,obj(i,4)-2

			Text obj(i,1)+2,obj(i,2)+1,	objText$(i)

			Viewport 0,0,scrnW,scrnH

		Case 7	;Hslider

			w=obj(i,3):h=obj(i,4)

			range=obj(i,7)-obj(i,6)

			Xpos=obj(i,1) + (obj(i,8)-obj(i,6))*w/range

			colorset(black)

			Rect Xpos-1,obj(i,2),3,h

			If obj(i,5) Then Text obj(i,1)+w+4,obj(i,2)+h/2,Str$(obj(i,8)),0,1

		Case 8	;Vslider

			w=obj(i,3):h=obj(i,4)

			colorset(white)

			range=obj(i,7)-obj(i,6)

			Ypos=obj(i,2) + (obj(i,8)-obj(i,6))*h/range

			colorset(black)

			Rect obj(i,1),Ypos-1,w,3

			If obj(i,5) Then Text obj(i,1)+w/2,obj(i,2)+h+4,Str$(obj(i,8)),1,0

		Case 10 ;list

			If obj(i,7)>0 Then SetFont(obj(i,7))

			fh=FontHeight()

			Origin obj(mObj,1),obj(mObj,2)

			colorset(White)

			Rect obj(i,1),obj(i,2),obj(i,3),obj(i,4)		;fill

			colorset(black)

			Rect obj(i,1),obj(i,2),obj(i,3),obj(i,4),0  ;border

			Viewport obj(mObj,1)+obj(i,1)+1,obj(mObj,2)+obj(i,2)+1,obj(i,3)-2,obj(i,4)-2

			

			VisibleLines=obj(i,3)/fh 

			For k=0 To visibleLines

				y=obj(i,2)+2+K*fh

				item=k+obj(i,5)					;k+1st item visible on list

				If item = obj(i,6) Then ;currenly selected item

				  colorset(red)

				  Rect obj(i,1),y-1, obj(i,3),fh+2

					colorset(black)

					Text obj(i,1)+2,y,Dlist$(item)

				ElseIf item>obj(i,8)

				Else

					Text obj(i,1)+2,y,Dlist$(item)

				EndIf

			Next 

			Viewport 0,0,GraphicsWidth(),GraphicsHeight()

		Case 11		;slider for list

			colorset(gray)

			Rect obj(i,1),obj(i,5),obj(i,3),obj(i,7)

		Case 12

			If obj(i,7)>0 Then SetFont(obj(i,7))

			fh=FontHeight()

			Viewport obj(mObj,1)+obj(i,1)+1,obj(mObj,2)+obj(i,2)+1,obj(i,3)-2,obj(i,4)-2

			colorset(white)

			Rect obj(i,1),obj(i,2),obj(i,3)-obj(i,4),obj(i,4)

			colorset(black)

			s=1+obj(i,6)*(obj(i,8)-1)	;start position to extract substring =Len()*(choice-1)

			t$=Mid$(objText$(i),s,obj(i,6))

			Text obj(i,1)+2,obj(i,2)+1,t$

			Viewport 0,0,GraphicsWidth(),GraphicsHeight()

		Case 13	;Animated image

			;obj(i,8)==current frame (high word), nFrames (low word)

			If MilliSecs()-obj(i,6)>obj(i,7) Then

				frame=obj(i,8) Shr 16 + 1

				frame=frame Mod (obj(i,8) And LowB) 

				obj(i,6)=MilliSecs()

				obj(i,8)=(obj(i,8) And LowB) + frame Shl 16

			EndIf

			frame=obj(i,8) Shr 16 

			DrawImage obj(i,5),obj(i,1),obj(i,2),frame

			Default

		End Select

  Next

	Origin 0,0



End Function



;*************************************************************************

Function Form_Control(D,Dhand,img)



	fx=obj(Form(D,1),1)

	fy=obj(Form(D,1),2)

	fw=obj(Form(D,1),3)

	fh=obj(Form(D,1),4)

	Repeat

		DrawBlock screenimage,0,0

		DrawBlock dHand,fx,fy

		Form_Update(D)

		mx=MouseX()

		my=MouseY()

		If MouseDown(1)

			If RectsOverlap(mx,my,1,1,fx,fy,fw,fh)

				sx=mx-fx

				sy=my-fy

				For n=1 To Form(D,0)

					objx=Form(D,n)

					If RectsOverlap(sx,sy,1,1,obj(objx,1),obj(objx,2),obj(objx,3),obj(objx,4)) Then

						Select 	obj(objx,0)

						Case 0

						Case 1 	;text (no background)

						Case 2 	;label

						Case 3 	;button

							While MouseDown(1)

								sx=mx-fx

								sy=my-fy

								If RectsOverlap(sx,sy,1,1,obj(objx,1),obj(objx,2),obj(objx,3),obj(objx,4)) Then

									obj(objx,8)=True

								Else

									obj(objx,8)=False

								EndIf

								DrawBlock screenimage,0,0

								DrawBlock dHand,fx,fy

								Form_Update(D)

								mx=MouseX()

								my=MouseY()

								DrawImage mouseImage,mx,my

								Flip

							Wend

							If obj(objx,8)=True Then Return objx

							obj(objx,8)=False

						Case 4 	;Ckbox

							obj(objx,8)=Not obj(objx,8)

							While MouseDown(1):Wend

							Return objx

						Case 5	;radio

							For k=1 To Form(D,0)

								r=Form(D,k)

								If obj(r,0)=5 And obj(r,6)=obj(objx,6) Then obj(r,5)=False

							Next

							obj(objx,5)=True

							While MouseDown(1):Wend

							Return objx

						Case 6	;edit Text box

							EditTextObj(D,objx)

							Return objx

						Case 7	;Hslider

							w=obj(objx,3)

							range=obj(objx,7)-obj(objx,6)

							While MouseDown(1)

								c=c+1

								HX=MouseX()-fx

								v=(HX-obj(objx,1)) * range/w+obj(objx,6)

								NewValue=MiniMax(v,obj(objx,6),obj(objx,7))

								If obj(objx,8)=NewValue Then

									FlushMouse

								Else

									obj(objx,8)=NewValue

									DrawBlock dHand,fx,fy

									Form_Update(D)

									DrawImage mouseImage,hx+fx,my

									Flip

								EndIf

							Wend

							Return objx

						Case 8	;Vslider

							h=obj(objx,4)

							range=obj(objx,7)-obj(objx,6)

							While MouseDown(1)

								Hy=MouseY()-fy

								v=(Hy-obj(objx,2)) * range/h+obj(objx,6)

								NewValue=MiniMax(v,obj(objx,6),obj(objx,7))

								If obj(objx,8)=NewValue Then

									FlushMouse

								Else

									obj(objx,8)=NewValue

									DrawBlock dHand,fx,fy

									Form_Update(D)

									FlushMouse 

									Flip

								EndIf

							Wend

							Return objx

						Case 9	;Title Bar drag

							dx=fx-mx

							dy=fy-my

							colorset(white)

							While MouseDown(1)

								mx=MouseX()

								my=MouseY()

								fx=MAX(mx+dx,0)

								fy=MAX(my+dy,0)

								DrawBlock screenimage,0,0

								Rect fx,fy,fw,fh,0

								DrawImage mouseImage,mx,my

								Flip

							Wend

							obj(Form(D,1),1)=fx

							obj(Form(D,1),2)=fy

						Case 10	;List box

							If obj(objx,7)>0 Then SetFont(obj(objx,7))

							ItemH=FontHeight()

							cItem=(my-obj(objx,2)-fy)/itemH + obj(objx,5)

							If cItem<obj(objx,8)+1 Then obj(objx,6)=cItem

							Return objx

						Case 11	;Listbox slider

							MaxPos=obj(objx,2)+obj(objx,4)-obj(objx,7)

							While MouseDown(1)

								Hy=MouseY()-fy

								;new slider position

								obj(objx,5)=MINIMAX(hy,obj(objx,2),MaxPos)

								;new list position

								List=obj(objx,6)

								;1st list item to print =nItems * (Slider Position-offset)/Slider area

								obj(List,5)=obj(List,8)*(obj(objx,5)-obj(objx,2))/obj(objx,4)+1

								DrawBlock dHand,fx,fy

								Form_Update(D)

								Flip

							Wend

							Return objx

						Case 12	;dropdown selector

							If obj(objx,7)>0 Then SetFont(obj(objx,7))

							ItemH=FontHeight()

							dh=ItemH*obj(objx,5)+2

							cItem=obj(objx,8)

							y0=fy+obj(objx,2)+obj(objx,4)

							

							While MouseDown(1)

								DrawBlock screenimage,0,0

								DrawBlock dHand,fx,fy

								Form_Update(D)

								mx=MouseX()

								my=MouseY()

								y=my-y0-2

								cItem=MINIMAX(Int(y/ItemH)+1,1,obj(objx,5))

								colorset(white)

								Rect fx+obj(objx,1),y0,obj(objx,3),dh

								colorset(black)

								Rect fx+obj(objx,1),y0,obj(objx,3),dh,0

								Viewport fx+obj(objx,1)+1,y0+1,obj(objx,3)-2,dh-2

								For k=1 To obj(objx,5)

									If k=cItem Then 

										colorset(RED)

										Rect fx+obj(objx,1)+2,y0+2+(k-1)*ItemH,obj(objx,3),ItemH

										colorset(black)

									EndIf

									s=1+obj(objx,6)*(k-1)	;start position to extract substring =Len()*(choice-1)

									t$=Mid$(objText$(objx),s,obj(objx,6))

									Text fx+obj(objx,1)+2,y0+2+(k-1)*ItemH,t$

								Next 

								Viewport 0,0,GraphicsWidth(),GraphicsHeight()

								DrawImage mouseImage,mx,my

								Flip

							Wend

							obj(objx,8)=cItem

							Return objx

						Case 13	;image

						Default

							Text 60,60,"object# "+Str$(objX)

						End Select

					EndIf

				Next

			Else

				;outside dialog box

			EndIf

		EndIf

		DrawImage mouseImage,mx,my

		Flip

	Until KeyDown(1)



End Function







Function EditTextObj(D,objx)

	mask$="any"

	If obj(objx,7)>0 Then SetFont(obj(objx,7))

	

	fw=FontWidth()+2

	h=FontHeight()+2

	r$=objText$(objx)

	

	pos=Len(r$)  ;location of cursor relative to text

	xpos=pos	 ;old cursor position



	;draw border and set clipping so everthing stays inside border

	mObj=Form(D,1)

	x=obj(mObj,1)+obj(objx,1)

	y=obj(mObj,2)+obj(objx,2)

	w=obj(objx,3)

	h=obj(objx,4)

	colorset(obj(objx,5)) 

	Origin x,y

	Rect 0,0,w,h,0		;border

	Viewport x+1,y+1,w-2,h-2





	Repeat

	  ;calc cursor and text positions

	  x0=StringWidth(Left$(r$,pos))

	  cpos=x0  ;location of cursor relative to screen

	  If cpos>w-Fw Then cpos=w-Fw



		;fill background	

		colorset(obj(objx,6))

	  Rect 0,0,w-2,h-2

	  ;draw text  

		colorset(obj(objx,5))

	  Text cpos-x0,1,r$

	  Line cpos+1,2,cpos+1,h-2

		Flip



    ;get keyboard input

	  Repeat

			action=False

			;check for end of editing

			If KeyDown(1) Then r$=objText$(objx):done=True 	;esc

			If KeyDown(156) Then done=True									;enter

			If KeyDown(28)  Then done=True									;enter

			;check deletions

			If KeyDown(14) Then      												;backspace

			  If pos>0 Then 

			 	r$=Left$(r$,pos-1)+Right$(r$,Len(r$)-pos)

				pos=pos-1

			  EndIf

			EndIf

			If KeyDown(211) Then      											;Delete

			  If pos<Len(r$) Then 

			 	r$=Left$(r$,pos)+Right$(r$,Len(r$)-pos-1)

				Action=True	 ;needed because position hasn't changed

			  EndIf

			EndIf

			

			;check keypad /ignores number lock

			keypad$=""

			If KeyDown(82) Then keypad$="0"

			If KeyDown(79) Then keypad$="1"

			If KeyDown(80) Then keypad$="2"

			If KeyDown(81) Then keypad$="3"

			If KeyDown(75) Then keypad$="4"

			If KeyDown(76) Then keypad$="5"

			If KeyDown(77) Then keypad$="6"

			If KeyDown(71) Then keypad$="7"

			If KeyDown(72) Then keypad$="8"

			If KeyDown(73) Then keypad$="9"

			If Len(keypad$) Then 

			  action=True

			EndIf

			

			;check for cursor movement

			If KeyDown(203) Then 							;left arrow

			  If pos>0 Then pos=pos-1 

			EndIf   

			If KeyDown(205) Then							;right arrow

			  If pos<Len(r$) Then pos=pos+1

			EndIf

			If KeyDown(199) Then pos=0 				;home

			If KeyDown(207) Then pos=Len(r$)	;end

			If pos<>xPos Then

			  action=True

			  xpos=pos

			EndIf

			

		  keyASC=GetKey()

	  	If (KeyASC>31 And KeyASC<127) Then c$=Chr$(KeyASC) Else c$=Keypad$

	

	  	If Len(c$) Then

	     	If mask$="any" Or Instr(mask$,c$) Then

				  If pos=Len(r$) Then 

				  	r$=r$+c$

				  ElseIf pos=0 Then

				  	r$=c$+r$

				  Else

				  	r$=Left$(r$,pos)+c$+Right$(r$,Len(r$)-pos)

				  EndIf

			  	pos=pos+1

		  	EndIf

				action= True

	   	EndIf

			keyUp()

	  Until action Or done

	Until done

	

	Viewport 0,0,GraphicsWidth(),GraphicsHeight()

	Origin 0,0

	objText$(objx)=r$

	

End Function



;*************************************************************************





Function keyUp()

	Repeat

		AllUp=True

		For i=1 To 237

			If KeyDown(i) Then AllUP=False

		Next

		If AllUp Then Return

	Forever

	FlushKeys()

End Function





;****************************************************





	

Function ALERT (nText,nButtons,img)

  ;Require Globals: aText$(),buttons$(),mouseImage 

  ;Img is the handle for the current screen image

  ;this routine sets the buffer to the backbuffer

  ;Set the font and backbuffer() before calling



  ;the esc key selects the last button

  ;enter selects the first button



  	;calc width and Height of Alert box

	;1st find longest button

	buttonW=StringWidth(Button$(1))

	For i=2 To nbuttons

		w=StringWidth(Button$(i))

		If w>buttonW Then buttonW=w

	Next 

	;Now find longest Line including button line

	w=(buttonW+20)*nButtons = 20  

	For i = 1 To nText

    	wd = StringWidth(AText$(I)) + 40

		If wd>w Then w=wd

  	Next 

	;Calculate Height

  	FontH=FontHeight()+4

  	h=(nText+1)*(FontH)+10

	;Calculate box cordinates To center Alert on screen

	bx = (GraphicsWidth() - w) / 2

	by = (GraphicsHeight() - H) / 2

	

    ;create images for the screen and Alert Box

	Abox=CreateImage(w,h)

		 

	;draw box 

	Origin bx,by

  	Color 255,0,0

  	Rect 0, 0, w , H

  	Color 130,130,130

  	Rect 2,2, w-4, H-4

  	Color 0,0,0

	;draw text

  	For i = 1 To nText

			If Left$(AText$(i),1)=" " Then

    		Text  20,  10+(i-1) * FontH  , AText$(i)

			Else

		   	Text  w/2,  10+(i-1) * FontH  , AText$(i),1,0

		  EndIf

  	Next

	;draw buttons

	wb=w/nButtons

	y=nText * FontH + 4

	For i=1 To nButtons

		Color 255,0,0

		x=wb*(i-1)

		Rect x+(wb-buttonW)/2,y,buttonW+4,FontH

		Color 0,0,0

		Rect x+(wb-buttonW)/2,y,buttonW+4,FontH,0

		Text x+wb/2+2,y+2,button$(i),1,0

	Next



	Origin 0,0

	GrabImage Abox,bx,by

	MoveMouse bx,by

	DrawImage mouseImage,bx,by

	Flip

	

	Repeat

		mx=MouseX()

		my=MouseY()

		If KeyDown(1) Then Pick=nButtons	

		If KeyDown(28) Then pick=1

		If MouseDown(1)

			;check to see whick button was pressed

			sx=mx-bx

			sy=my-by

			If sy>y And sy-y<FontH+4 Then

			  ;the pointer is on the button Line

			  For i=1 To nButtons

				x=wb*(i-1)+wb/2

				If Abs(sx-x)<wb/2 Then Pick=i

			  Next

			ElseIf RectsOverlap(sx,sy,1,1,0,0,w,h) Then

			  ;the mouse is down inside the box, repostion box

			  Repeat

				gx=MouseX()

				gy=MouseY()

				DrawBlock img,0,0

				DrawBlock Abox,bx+(gx-mx),by+(gy-my)

				DrawImage MouseImage,gx,gy

				Flip

			  Until Not MouseDown(1)

			  bx=bx+(gx-mx)

			  by=by+(gy-my)

			EndIf

		EndIf

		DrawBlock img,0,0

		DrawBlock Abox,bx,by

		Color 255,0,0

		DrawImage mouseImage,mx,my

		Flip

	Until Pick

	

	DrawBlock img,0,0	;restore the screen

	FreeImage aBox

	Flip

	While MouseDown(1):Wend			;wait for mouse release before returning

	Return pick



End Function





Function Message (msg$, msecs,scrnImage)

  ;The calling routine needs to pass a image of the screen w/o the mouse

  If scrnImage = 0 Then Stop: Return



  FontH=FontHeight()

  FontW=FontWidth()

  rbuffer=GraphicsBuffer()



  bx = 300: by = 200

  ;Determine number of lines in message

  For i = 1 To Len(msg$)

    If Mid$(msg$, i, 1) = "|" Then k = k + 1

  Next 



  ;seperate message into seperate lines

  Dim MessageTxt$(k + 1)

  For i = 1 To k

    P = Instr(msg$, "|")

    MessageTxt$(i) = Left$(msg$, P - 1)  

    msg$ = Right$(msg$, Len(msg$) - P)

  Next 

  MessageTxt$(k + 1) = msg$

  

  ;find longest Line

  ww = StringWidth(" ANYKEY ")+20

  MaxL=ww

  For i = 1 To k + 1

    m = StringWidth(MessageTxt$(i))

    If m > MaxL Then MaxL = m

  Next 



  ;create message image box

  H = (k+3) * (FontH + 6)

  w =  MaxL  + 40

  mhandle=CreateImage(w,H)

  mBuff=ImageBuffer(mHandle)

  SetBuffer(mBuff)



  ;draw message graphics

  colorset(red)

  Rect 0,0, w, H,1

  colorset(White)

  Rect 2, 2, w-4 , H-4

  colorset(red)

  For i = 1 To k + 1

    Text  18,  i * (FontH+6) - 4, MessageTxt$(i)

  Next 



  ;create anykey button to close message before time expires

  If msecs <> 0  Then

	x1= w /2-25

	y1=H-FontH-8

    ButtonBox(x1,y1,0,0," OK  ",fnt,red,white,0)

  EndIf



  SetBuffer BackBuffer()

  DrawBlock	scrnImage,0,0

  DrawBlock mHandle, bx,by

  Flip



  If msecs = 0 

	;message stays on screen only while button is down

	Repeat

	  DrawBlock	scrnImage,0,0

	  DrawBlock mHandle, bx,by

	  DrawImage MouseImage,bx+100,by+100

	  Flip

    Until MouseDown(1)+MouseDown(2)=0

  Else

    t1 = MilliSecs() 

	;Flush keys and wait for mouse release

	FlushKeys()

	Repeat: Until MouseDown(1)=0

	Delay 200

	Repeat

	  DrawBlock	scrnImage,0,0

	  DrawBlock mHandle, bx,by

	  DrawImage MouseImage,MouseX(),MouseY()

	  Flip

      If GetKey() Then Exit

      If MouseDown(1) Then Exit 

    Until MilliSecs() - t1 > msecs

  End If

  ;leave passed screen image on backbuffer

  DrawBlock	scrnImage,0,0

  SetBuffer rbuffer  ;restore orginal buffer

  FreeImage mhandle  ;release message image block



End Function



;*************************************************************************



Function EditTextBox$(x,y,w,fnt,r$,mask$,Bcolor,Fillcolor,Textcolor)

	;Uses front buffer

	;Restores Front buffer on exit

	;resets Buffer to previous buffer on exit

	

	;restore info

	current_buffer=GraphicsBuffer()

	If fnt<>0 Then SetFont fnt

	fw=FontWidth()+2

	h=FontHeight()+2

	temp=CreateImage(w,H)

	SetBuffer FrontBuffer()

	GrabImage temp,x,y

	r0$=r$

	

	pos=Len(r$)  ;location of cursor relative to text

	xpos=pos	 ;old cursor position

	;draw border and set clipping so everthing stays inside border

  	ColorSet(Bcolor)

  	Rect x,y,w,h

	Viewport x+1,y+1,w-2,h-2

	Origin x+1,y+1

	

	Repeat

	  ;calc cursor and text positions

	  x0= StringWidth(Left$(r$,pos))

	  cpos=x0  ;location of cursor relative to screen

	  If cpos>w-Fw Then cpos =w-Fw

	

	  ;draw text  

	  colorSet(Fillcolor)

	  Rect 0,0,w-2,h-2

	  colorSet(textColor)

	  If fnt<>0 Then SetFont fnt

	  Text cpos-x0,1,r$

	  Line cpos+1,2,cpos+1,h-2



      ;get keyboard input

	  Repeat

		action=False

		;check for end of editing

		If KeyDown(1) Then r$=r0$:done=True ;esc

		If KeyDown(156) Then done=True		;enter

		If KeyDown(28)  Then done=True		;enter

		;check deletions

		If KeyDown(14) Then      			;backspace

		  If pos>0 Then 

		 	r$=Left$(r$,pos-1)+Right$(r$,Len(r$)-pos)

			pos=pos-1

		  EndIf

		EndIf

		If KeyDown(211) Then      			;Delete

		  If pos<Len(r$) Then 

		 	r$=Left$(r$,pos)+Right$(r$,Len(r$)-pos-1)

			Action=True	 ;needed because position hasn't changed

		  EndIf

		EndIf

		

		;check keypad /ignores number lock

		keypad$=""

		If KeyDown(82) Then keypad$="0"

		If KeyDown(79) Then keypad$="1"

		If KeyDown(80) Then keypad$="2"

		If KeyDown(81) Then keypad$="3"

		If KeyDown(75) Then keypad$="4"

		If KeyDown(76) Then keypad$="5"

		If KeyDown(77) Then keypad$="6"

		If KeyDown(71) Then keypad$="7"

		If KeyDown(72) Then keypad$="8"

		If KeyDown(73) Then keypad$="9"

		If Len(keypad$) Then 

		  action=True

		EndIf

		

		;check for cursor movement

		If KeyDown(203) Then 				;left arrow

		  If pos>0 Then pos=pos-1 

		EndIf   

		If KeyDown(205) Then				;right arrow

		  If pos<Len(r$) Then pos=pos+1

		EndIf

		If KeyDown(199) Then pos=0 			;home

		If KeyDown(207) Then pos=Len(r$)	;end

		If pos<>xPos Then

		  action=True

		  xpos=pos

		EndIf

		

	  	KeyASC=GetKey()

  	  	If (KeyASC>31 And KeyASC<127) Then c$=Chr$(KeyASC) Else c$=Keypad$



	  	If Len(c$) Then

	     If mask$="any" Or Instr(mask$,c$) Then

		  If pos=Len(r$) Then 

		  	r$=r$+c$

		  ElseIf pos=0 Then

		  	r$=c$+r$

		  Else

		  	r$=Left$(r$,pos)+c$+Right$(r$,Len(r$)-pos)

		  EndIf

		  pos=pos+1

	     EndIf

		 action= True

		 FlushKeys()

   	  	EndIf

	  	Delay 60

	

	  Until action Or done

	Until done

	

	Viewport 0,0,GraphicsWidth(),GraphicsHeight()

	Origin 0,0

	DrawBlock temp,x,y

	FreeImage temp

	SetBuffer current_buffer

	Return r$

End Function



;*************************************************************************



Function TextBox(x,y,w,h,r$,fnt,b,f,t,c)

	;draws text inside a define box on current buffer

	If fnt<>0 Then SetFont fnt

	If w=0 Then w=StringWidth(r$)+4

	If h=0 Then h=FontHeight()+4

	

 	ColorSet(B)		;Border

 	Rect x,y,w,h

	colorSet(F)		;Fill

	Rect x+1,y+1,w-2,h-2

	colorSet(T)		;Text

	If c=0 Then

	  Text x+2,y+2,r$

	Else

	  Text x+1+w/2,y-1+h/2,r$,1,1

	EndIf

End Function



;*************************************************************************