Function Point_Insert(Seg,M,img)

	nLineSeg=nLineSeg+1

	MasRect(M,6)=MasRect(M,6)+1		;number of points contain in Master Rect

	LineSeg(nLineSeg,0)=M		 	;Parent

	Pseg=LineSeg(seg,6)

	LineSeg(nLineSeg,1)=(LineSeg(seg,1)+LineSeg(Pseg,1)) Shr 1	

	LineSeg(nLineSeg,2)=(LineSeg(seg,2)+LineSeg(Pseg,2)) Shr 1	

	

	LineSeg(nLineSeg,5)= seg	;next= current segiment

	LineSeg(nLineSeg,6)= Pseg	;prev  = current segiments previous segiment

	LineSeg(Seg,6)=nLineSeg		;update current segiment to point back to new segiment	

	LineSeg(Pseg,5)=nLineSeg	;update previous(seg) segiment to point to new segiment

	Point_set(M,nLineSeg)



	Master_MinMax(M)

	DrawBlock img,0,0	

	Master_Draw(M)

	GrabImage img,0,0



End Function 





Function Point_set(M,Seg)

  Select MasRect(M,0)

  Case 1	;line

		LineSeg(Seg,3)=0 					

		LineSeg(Seg,4)=0 					

  Case 2	;fractal

		LineSeg(Seg,3)=MilliSecs()		;random number seed

		LineSeg(Seg,4)=10+ (4 Shl 8) + (55 Shl 16) 					

  Case 3	;bezier

	;put control midway between current segiment point and next point

		LineSeg(Seg,3)=(LineSeg(Seg,1)+ LineSeg(LineSeg(Seg,5),1)) Shr 1

		LineSeg(Seg,4)=(LineSeg(Seg,2)+ LineSeg(LineSeg(Seg,5),2)) Shr 1

  End Select

  Return

End Function





Function Point_add()

	For s=1 To nLineSeg

		If LineSeg(s,0)=0 Then Return s

	Next 

	nLineSeg=nLineSeg+1

	Return nLineSeg

End Function	





Function Point_Delete(Seg,M,img)



	If MasRect(M,6)=3 Then Return 	;must have at least 3 points

	If MasRect(M,5)=seg Then 

		message("Can't delete first segment!",3000,img)

		Return

	EndIf

	MasRect(M,6)=MasRect(M,6)-1		;number of points contain in Master Rect	

	Pseg=LineSeg(seg,6)

	Nseg=LineSeg(Seg,5)

	If masrect(M,0)=3 Then 

	  LineSeg(PSeg,3)=LineSeg(Seg,1)

	  LineSeg(PSeg,4)=LineSeg(Seg,2)

	EndIf

	For i=0 To 6

	  LineSeg(Seg,i)=0		 				

	Next



	LineSeg(Pseg,5)= Nseg		

	LineSeg(Nseg,6)= Pseg	

	Master_MinMax(M)

	DrawBlock img,0,0	

	Master_Draw(M)

	GrabImage img,0,0

	Return

	

End Function





Function Point_Move(Seg,M,img)

	DrawScreenImage(img,M)

	While MouseDown(1)

		mx=MouseX():  	x2=mx+MapX-WinX

		my=MouseY():	y2=my+MapY-WinY

		x2=Limit(x2,MasRect(M,1),MasRect(M,3))

		y2=Limit(y2,MasRect(M,2),MasRect(M,4))

		;origin for line segiments is master x,y

		LineSeg(Seg,1)=x2-MasRect(M,1)

		LineSeg(Seg,2)=y2-MasRect(M,2)

		DrawBlock img,0,0

		UpdatePosition(mx,mY,"Point_Move")

		Master_Draw(M)

		ColorSet(white)

		Text 0,0,Str$(x2)+"  "+Str$(y2)

		DrawImage MouseImage, mx,my

		Flip

	Wend

	Master_MinMax(M)

	DrawBlock img,0,0	

	Master_Draw(M)

	GrabImage img,0,0

	Return

End Function 



	

Function Point_Find(M,sx,sy)

 	If M<>Master_Find(sx,sy) Then Return -1

	Seg=MasRect(M,5)

	Repeat

	  x=LineSeg(Seg,1)+MasRect(M,1)-3

	  y=LineSeg(Seg,2)+MasRect(M,2)-3

	  If RectsOverlap(sx,sy,1,1,x,y,7,7) Then 

		Return seg

	  Else

		seg=LineSeg(Seg,5)

	  EndIf

	  If LineSeg(Seg,0)<>M Then Return 0

	Until Seg=MasRect(M,5)

	Return 0

End Function 



