;Const nMenus=5,nSubMenus=6

;Dim nSubm(nMenus,1), Submenu$(nMenus,nSubMenus)  

;Dim ret$(nMenus,nSubMenus), keyVal(nMenus,nSubMenus)

;Global MENUWidth,MENUHeight

;MENUWidth=FontWidth()*12

;MenuHeight=FontHeight()+6







Function MENU_Activate (X, Y)

	;checks whether mouse is down over menu bar

	If Not MouseDown(1) Then Return False

  If Y > MENUHeight Then

    Return  False

  ElseIf X > MENUWidth*nMenus Then

    Return  False

  Else

		Return  True

  End If

End Function





Function Menu_Load()

	;function to load menu from data statements

  For M = 1 To nMenus: nSubm(M,1) = -1: Next 

  Repeat 

    Read M,txt$, r$, keyN

		nSubm(M,1) = nSubm(M,1) + 1

  	If nSubm(M,1) >nSubMenus Then

		  Stop

		  nSubm(M,1) = nSubm(M,1) - 1

		ElseIf Upper$(txt$)="END MENU DATA"

		  nSubm(M,1) = nSubm(M,1) - 1

		  Exit

  	Else

      SubMenu$(M, nSubm(M,1)) = txt$

		  ret$(M, nSubm(M,1)) = r$

      keyVal(M, nSubm(M,1)) = keyN

  	End If

  Forever

End Function





Function MENU_Assign (M, txt$, r$, keyN)

	;Funtion to directly put menu data into the menu arrays

  nSubm(M,1) = nSubm(M,1) + 1

  If nSubm(M,1) >nSubMenus Then

  Else

    SubMenu$(M, nSubm(M,1)) = txt$

		ret$(M, nSubm(M,1)) = r$

    keyVal(M, nSubm(M,1)) = keyN

  End If

End Function





Function MENU_Get$ (mx,img)

	;Function to control screen while user is selecting a menu item

	;mx=mouse X, img=screenimage

	

  tmenu = MiniMax(Int((mx-winX) / MenuWidth) + 1,1,nMenus)

  temp=CreateImage(scrnW,scrnH)

  MENU_drawSubMenu(tMenu,cMenu,img,temp)

  DrawBlock temp,0,0

  DrawImage mouseImage,MouseX(),MouseY()

  Flip

  Repeat: Until Not MouseDown(1)	;wait for mouse release

  

  Repeat

		mx=MouseX()

		my=MouseY()

    Tx = MiniMax(Int((mx-WinX) / MenuWidth) + 1,1,nMenus)

    Ty = MiniMax((my)/MenuHeight,1,nSubm(tx,1))

    If Tx <> tmenu Or Ty <> cMenu 

      tmenu = Tx

      cMenu = Ty

	  	call= MENU_drawSubMenu(tMenu,cMenu,img,temp)

		End If

    DrawBlock temp,0,0

    DrawImage mouseImage,mx,my

    Flip

  Until MouseDown(1)



  FreeImage temp

  If MouseX() > MenuWidth*nMenus Then

    Return  ""

  Else If MouseY()> (nSubm(Tx,1)+1)*MenuHeight Then

    Return ""

  Else 

    Return ret$(Tx, Ty)

  End If

End Function





Function MENU_DRAW()

  ;Draws to active buffer

  ;Draw Menubar

  Origin winX,0

  Color 0,0,255

  Rect 0,0,MENUWidth*nMenus,MENUHeight

  Color 255,255,255

  Line 0,MENUHeight-1,MENUWidth * nMenus,MENUHeight-1

  If MenuFnt>0  Then SetFont MenuFnt

  For M = 1 To nMenus

     Text MenuWidth * (M - 1), 0, SubMenu$(M, 0)

  Next 

  Origin 0,0

End Function





Function MENU_DrawSubMenu$(tMenu,cMenu,img1,img2)

	;tmenu = active main menu

	;cmMenu = active item umder main menu

	;img1 = screen image

	;img2 = returned screen image with menu on it

	

  ;background screen image

  DrawBlock img1, 0,0

  ;window offset			

  Origin winX,MENUHeight			

  ;width of current submenu

  w=nSubm(tMenu,2)

  ;paste drop down menu list on screen

  DrawImage nSubm(tMenu,0),MENUWidth * (tmenu - 1),0

  ;inverse (over) print current submenu

  Color 255,255,255					

  y0=(cMenu-1) * MENUHeight

  x0=MENUWidth * (tmenu - 1)

  Rect 	x0+2, y0+1,w-5,MENUHeight

  Color 0,0,255

  If MenuFnt>0  Then SetFont MenuFnt

  Text 	x0+4, y0+2, SubMenu$(tmenu, cMenu)

  Origin 0,0

  ;screen image with submenu on it

  GrabImage img2,0,0				



End Function





Function MENU_Image(t)

	;creates then menu images 

	;t=main menu heading #

	

  Cls

  w=MENUWidth

  If MenuFnt>0  Then SetFont MenuFnt

  For n = 1 To nSubm(t,1)

		w=MAX(StringWidth(SubMenu$(t, n))+6,w)

  Next

  nSubm(t,2)=w

  h=nSubm(t,1) * MENUHeight+4



  Origin 0,MENUHeight

  Color 0,0,255

  Rect  0,0,w,h					;inside

  Color 255,0,0

  Rect  0, 0,w,  h,0		;shadow border

  Rect  0, 0,w-1,h-1,0

  Line  0, h-2,w-1,h-2

  Color 255,255,255

  Line  0,0,w-1,0				;light border

  Line  0,0,0,h-1



  For n = 1 To nSubm(t,1) 

  	Color 255,255,255

    Text 4, (n-1) * MENUHeight+2, SubMenu$(t, n)

  Next  

  nSubm(t,0)=CreateImage(w+2,h+2)

  GrabImage nSubm(t,0),0,0

  Origin 0,0

End Function





Function MENU_KEY$()

  ; Check For menu hot key

	; KeyVal() contains scan codes! 

  For M = 1 To nMenus

    For n = 1 To nSubm(M,1)

      If KeyDown(keyVal(M, n)) Then 

				While KeyDown(keyVal(M, n)): Wend  ;wait for key release

				Return  ret$(M, n)

			EndIf

    Next 

  Next 

	Return ""

End Function





Function MENU_Make()

	;example function for using Menu_assign to fill menu arrays

  For M = 1 To nMenus: nSubm(M,1) = -1: Next 

     

  MENU_ASSIGN 1, "FILE", "", 0

  MENU_ASSIGN 1, "Credits", "CRED", 0

  MENU_ASSIGN 1, "NEW Game    ", "NEWG", 0

  MENU_ASSIGN 1, "Hotseat OFF", "HOTS", 0

  MENU_ASSIGN 1, "Load      F6", "LOAD", 1064

  MENU_ASSIGN 1, "Save      F7", "SAVE", 1065

  MENU_ASSIGN 1, "Quit     esc", "QUIT", 27



  MENU_ASSIGN 2, "GAME", "", 0

  MENU_ASSIGN 2, "UNDO Move  Z", "UNDO", Asc("Z")

  MENU_ASSIGN 2, "NextPhase F2", "NEXT", 1060

  MENU_ASSIGN 2, "Victory Pts", "CKVP", 0



  MENU_ASSIGN 3, "Options", "", 0

  MENU_ASSIGN 3, "Dots are OFF", "DOTS", 0

  MENU_ASSIGN 3, "HEXs are OFF", "HEXS", 0

  MENU_ASSIGN 3, "Nums are OFF", "HEXN", 0

  MENU_ASSIGN 3, "Minimap =OFF", "MMAP", 0

  MENU_ASSIGN 3, "Hex Cord =ON", "ACOR", 0

 

  MENU_ASSIGN 4, "Map", "", 0

  MENU_ASSIGN 4, "Edit Colors ", "COED", 0

  MENU_ASSIGN 4, "Co-ord Sys  ", "CORD", 0

  MENU_ASSIGN 4, "INC aHEX", "HEX+", 0

  MENU_ASSIGN 4, "DEC aHEX", "HEX-", 0

  MENU_ASSIGN 4, "aHex = " + Str$(aHex), "", 0



  MENU_ASSIGN 5, "HELP ", "", 0

  MENU_ASSIGN 5, "View CRT    ", "VCMB", 0

  MENU_ASSIGN 5, "Help File F1", "HELP", 1059

  MENU_ASSIGN 5, "Save Scrn F8", "SCRN", 1066

  MENU_ASSIGN 5, "Message Secs", "MSGL", 0

  MENU_ASSIGN 5, "CkDraw   off", "CKDR", 0



  If CDOTS Then call = MENU_Toggle( "Dots are  ON", "DOTS")

  If HEXs Then call = MENU_Toggle( "HEXs are  ON", "HEXS")

  If HNUMS Then call = MENU_Toggle( "Nums are  ON", "HEXN")

  If MMAP Then call = MENU_Toggle( "Minimap = ON", "MMAP")

  If ARRAYN Then call = MENU_Toggle( "ArrayCord ON", "ACOR")

End Function





Function MENU_Toggle(MenuText$, r$)

  ;changes the menu text for the menu 

  ;entry with a Return value of r$

	;MenuText$= new menutext$

	;r$ = return text value of menu item, used for matching

	

  For M = 1 To nMenus

    For n = 1 To nSubmenus

      If r$ = ret$(M, n) Then

				;found a match, change and return

				;menu_image needs to be called to update image

        SubMenu$(M, n) =  MenuText$

        Return

      End If 

    Next 

  Next

End Function